zoukankan      html  css  js  c++  java
  • [LeetCode] Clone Graph

    This problem is an application of graph traversal, which has two systematic methods: Bread-First Search (BFS) and Depth-First Search (DFS). In the following, I am going to assume that you are familiar with them and just focus on what I think is the most tricky part of this problem, that is, what else is needed beyond graph traversal to clone a graph?

    In order to clone a graph, you need to have a copy of each node in the original graph. Well, you may not have too many ideas about it. Let's do an example.

    Suppose we are given a graph {0, 1 # 1, 0}. We know that the graph has two nodes 0 and1 and they are connected to each other.

    We now start from 0. We make a copy of 0. Then we check 0's neighbors and we see 1. We make a copy of 1 and we add the copy to the neighbors of the copy of 0. Now the cloned graph is {0 (copy), 1 (copy)}. Then we visit 1. We make a copy of 1... well, wait, why do we make another copy of it? We already have one! Note that if you make a new copy of the node, these copies are not the same and the graph structure will be wrong! This is just what I mean by "the most tricky part of this problem". In fact, we need to maintain a mapping from each node to its copy. If the node has an existed copy, we simply use it. So in the above example, the remaining process is that we visit the copy of 1 and add the copy of 0 to its neighbors and the cloned graph is eventually {0 (copy), 1 (copy) # 1 (copy), 0 (copy)}.

    Note that the above process uses BFS. Of course, you can use DFS. The key is the node-copy mapping, anyway.


    BFS 

     1 class Solution {
     2 public:
     3     UndirectedGraphNode *cloneGraph(UndirectedGraphNode *node) {
     4         if (!node) return NULL;
     5         UndirectedGraphNode* copy = new UndirectedGraphNode(node -> label);
     6         mp[node] = copy;
     7         queue<UndirectedGraphNode*> toVisit;
     8         toVisit.push(node);
     9         while (!toVisit.empty()) {
    10             UndirectedGraphNode* cur = toVisit.front();
    11             toVisit.pop();
    12             for (int i = 0; i < (int)cur -> neighbors.size(); i++) {
    13                 UndirectedGraphNode* neigh = cur -> neighbors[i];
    14                 if (mp.find(neigh) == mp.end()) {
    15                     UndirectedGraphNode* neigh_copy = new UndirectedGraphNode(neigh -> label);
    16                     mp[neigh] = neigh_copy;
    17                     toVisit.push(neigh);
    18                 }
    19                 mp[cur] -> neighbors.push_back(mp[neigh]);
    20             }
    21         }
    22         return copy;
    23     }
    24 private:
    25     unordered_map<UndirectedGraphNode*, UndirectedGraphNode*> mp;
    26 };

    DFS

    This very succinct DFS code is taken from this post.

     1 class Solution {
     2 public:
     3     UndirectedGraphNode *cloneGraph(UndirectedGraphNode *node) {
     4         if (!node) return NULL;
     5         if (mp.find(node) == mp.end()) {
     6             mp[node] = new UndirectedGraphNode(node -> label);
     7             for (UndirectedGraphNode* neigh : node -> neighbors)
     8                 mp[node] -> neighbors.push_back(cloneGraph(neigh));
     9         }
    10         return mp[node];
    11     }
    12 private:
    13     unordered_map<UndirectedGraphNode*, UndirectedGraphNode*> mp;
    14 };

    If you want to learn more about this problem, you may refer to this article.

  • 相关阅读:
    利用python做矩阵的简单运算(行列式、特征值、特征向量等的求解)
    numpy.linalg.svd函数
    梯度裁剪(Clipping Gradient):torch.nn.utils.clip_grad_norm
    tf.matmul()报错expected scalar type Float but found Double
    1283 最小周长
    1182 完美字符串
    1091 线段的重叠
    1090 3个数和为0
    1087 1 10 100 1000
    1083 矩阵取数问题
  • 原文地址:https://www.cnblogs.com/jcliBlogger/p/4597940.html
Copyright © 2011-2022 走看看